// readConfiguration.c
// see url = http://www.daniweb.com/software-development/c/code/216535
// for sscanf for string fields
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "configuration.h" 

/*
struct configuration {
        char Description[80];
        int interfaceType;
        int debugLevel;
        int printLevel;
        int numForAve;
        int msleep1;
        int msleep2;
        double vSourceLowLimit;
        double vSourceHighLimit;
        double vSourceAtTermination;
        int numLoops;
        double startValues[10], stopValues[10];
        int numberOfIntervals[10];
};
*/


void removeMultpleBlankChar( char *s1, char *s2 ){
	char *tmp;
	while ( *s1 != '\0' ) {
		*s2 = *s1;
		tmp=s1;
		s1++;
		s2++;
		if ( *s1 == ' ' && *tmp == ' ' ) s2--;
		if ( *s1 == '\t' && *tmp == '\t' ) s2--;
	}
	*s2 = *s1;	// make sure to get the NULL
	return;
}

void removeLeadingBlankChar( char *s1, char *s2 ){
	if ( *s1 == ' ' || *s1 == '\t') s1++;
	 while ( *s1 != '\0' ) {
		*s2 = *s1;
		s1++;
                s2++;
	}
	*s2 = *s1;	// make sure to get the NULL
	return;
}

struct configuration readaConfiguration(char *filename, struct configuration IVconfiguration) {

	FILE *fd1;

	char s[100];
	char *line=NULL;
	size_t len = 0;
	size_t read;
	char field [100];
        char stmp1[100], stmp2[100];
        int n;
        char *subs1=NULL, *subs2=NULL;
        double dSubs1, dSubs2;
	int i,j;


	// local variable ... which can later be removed.
	int interfaceType, debugLevel, printLevel, numForAve, msleep1, msleep2;
	double vSourceLowLimit, vSourceHighLimit, vSourceAtTermination;
	int numLoops;
	double startValue, stopValue;
	int numberOfInterval;
	double startValues[10], stopValues[10];
        int numberOfIntervals[10];



	//fd1=fopen("configuration.dat", "r");
	fd1=fopen(filename, "r");

	//read = getline(&line, &len, fd1);	// not available to LabWindows/CVI
	line = fgets(s, sizeof(s),fd1);
	strcpy(IVconfiguration.Description, line);

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&interfaceType);
	IVconfiguration.interfaceType=interfaceType;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&debugLevel);
	IVconfiguration.debugLevel=debugLevel;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&printLevel);
	IVconfiguration.printLevel=printLevel;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&numForAve);
	IVconfiguration.numForAve=numForAve;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&msleep1);
	IVconfiguration.msleep1=msleep1;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&msleep2);
	IVconfiguration.msleep2=msleep2;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%10[^ ]%n",field,&n);
	vSourceLowLimit = strtod(field,NULL);
	IVconfiguration.vSourceLowLimit=vSourceLowLimit;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%10[^ ]%n",field,&n);
	vSourceHighLimit = strtod(field,NULL);
	IVconfiguration.vSourceHighLimit=vSourceHighLimit;

	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%10[^ ]%n",field,&n);
	vSourceAtTermination = strtod(field, NULL);
	IVconfiguration.vSourceHighLimit=vSourceHighLimit;

	fscanf(fd1,"%d\n",&numLoops );
	//read = getline(&line, &len, fd1);
	line = fgets(s, sizeof(s),fd1);
	sscanf(line,"%d",&numLoops);
	IVconfiguration.numLoops=numLoops;
	if ( numLoops > 10 ) {
		printf ( "Asked to too many loops! Stop at 10.\n");
		numLoops=10;
	}


	for (i=0;i<numLoops;i++) {
		//read = getline(&line, &len, fd1);
		line = fgets(s, sizeof(s),fd1);
		removeMultpleBlankChar(line, stmp1);
		removeLeadingBlankChar(stmp1, stmp2);
		line = stmp2;
		for (j=0;j<3;j++) {
			sscanf(line,"%79[^\t ]%n",field,&n);
			if (j==0) startValue=strtod(field,NULL);
			if (j==1) stopValue=strtod(field,NULL);
			if (j==2) numberOfInterval=strtol(field,NULL,0);
			line += n;
			++line;
		}
		startValues[i]=startValue;
		stopValues[i]=stopValue;
		numberOfIntervals[i]=numberOfInterval;
		IVconfiguration.startValues[i]=startValue;
		IVconfiguration.stopValues[i]=stopValue;
		IVconfiguration.numberOfIntervals[i]=numberOfInterval;
	}

// get summary
	if ( printLevel >= 1 ) {
	   printf("From 'readaConfiguration':\n");
	   printf("Interface Type is %d\n", interfaceType);
	   printf("debugLevel=%d printLevel=%d\n", debugLevel,printLevel);
	   printf("msleep1=%d msleep2=%d\n", msleep1,msleep2);
	   printf("vSourceLowLimit=%f\n", vSourceLowLimit);
	   printf("vSourceHighLimit=%f\n", vSourceHighLimit);
	   printf("numbLoops=%d\n", numLoops);
	   for (i=0;i<numLoops;i++) {
	   	printf("For loop=%d %f %f %d intervalSize=%f\n", i+1, startValues[i], stopValues[i], numberOfIntervals[i], 
	   		(stopValues[i]-startValues[i])/numberOfIntervals[i]);
	   }
	   printf("Summary Complete!\n");
	}
	
	fclose(fd1);
	return IVconfiguration;
}

#ifdef DLINES
int main(void) {
	char *filename="configuration.dat";
	struct configuration IVconfiguration;
	
	IVconfiguration=readaConfiguration(filename, IVconfiguration); 

	printf("in main:interfaceType=%d\n", IVconfiguration.interfaceType);
	printf("in main:debugLevel=%d\n", IVconfiguration.debugLevel);
	printf("in main:numLoops=%d\n", IVconfiguration.numLoops);

	return 0;
}
#endif
