// stats.c  

#include <stdio.h>
#include <math.h>

float gaussian( float mean, float std );

double calcMean( double * arrayOfValues, int lengthOfArray ) {

	double mean = 0.0;
	int i;

	for (i=0; i<lengthOfArray; i++) {
		mean = mean + arrayOfValues[i];
	}

	mean = mean / lengthOfArray;

	return mean;

}

double calcStdDev( double * arrayOfValues, int lengthOfArray ) {
	double mean =0.0, x2 =0.0, stddev=0.0;

	int i;

	for (i=0; i<lengthOfArray; i++) {
                mean = mean + arrayOfValues[i];
		x2 = x2 + arrayOfValues[i] * arrayOfValues[i];
	}
	mean = mean/lengthOfArray;
	stddev = sqrt(x2/lengthOfArray - mean*mean);
	
	return stddev;

}

#ifdef TEST
	
#define NSIZE	1000
#define SAMPLE   100

int main(void) {
	double array[NSIZE];
	int i=0,j=0;
	double means[SAMPLE], stds[SAMPLE];
	double meanOfMeans=.0, meanOfStds=0.0;
	double stdOfMeans=0.0, stdOfStds=0.0;

	srandom(137);
	for (i=0; i<NSIZE; i++) array[i] = gaussian(10.0, 1.0);

	printf(" mean = %f\n", calcMean( array, NSIZE) );
	printf(" stddev = %f\n", calcStdDev( array, NSIZE) );

	for (i=0;i<NSIZE; i=i+SAMPLE) {
		means[j] = calcMean( &array[i], SAMPLE );
		stds[j] = calcStdDev( &array[i], SAMPLE );
		j=j+1;
	}
	printf("j=%d subsample each of size %d from total of %d\n",j,SAMPLE,NSIZE);
	for (i=0; i<(NSIZE/SAMPLE); i++) {
		printf(" mean of %d = %f stdev of %d = %f\n", SAMPLE, means[i], SAMPLE, stds[i]);	
	}
	meanOfMeans = calcMean( means, NSIZE/SAMPLE);
	meanOfStds  = calcMean( stds,  NSIZE/SAMPLE);
	stdOfMeans  = calcStdDev( means, NSIZE/SAMPLE);
	stdOfStds  = calcStdDev( stds, NSIZE/SAMPLE);
	printf("meanOfMeans = %f  meanOfStds = %f \n", meanOfMeans, meanOfStds);
	printf("stdOfMeans  = %f  stdOfStds  = %f \n", stdOfMeans, stdOfStds);
	

	return 0;
}
#endif
